<!-- GENERATED BY A EUPHORIA PROGRAM. DO NOT EDIT! -->


<html>
<head><title>Euphoria Database System</title>
<style type="text/css">
<!--
body        {background-color: "#FFFFFF";}
a           {text-decoration: none;}
a:link      {color: "#0033BB"; text-decoration: underline;}
a:visited   {color: "#006699"; text-decoration: underline;}
a:active    {color: red; text-decoration: underline;}
a:hover     {color: red; text-decoration: underline;}
a.blue    {text-decoration: none;}
a.blue:link      {color: "#5500FF"; text-decoration: underline;}
a.blue:visited   {color: "#5500FF"; text-decoration: underline;}
a.blue:active    {color: red; text-decoration: underline;}
a.blue:hover     {color: red; text-decoration: underline;}
a.brown      {text-decoration: none;}
a.brown:link      {color: "#993333"; text-decoration: underline;}
a.brown:visited   {color: "#993333"; text-decoration: underline;}
a.brown:active    {color: red; text-decoration: underline;}
a.brown:hover     {color: red; text-decoration: underline;}
-->
</style>

</head>
<body bgcolor="#FFFFFF" link="#0033BB" vlink="#006699">
<table width=90% border=0><tr><td>

<center><font face="Arial, Helvetica" color="#FF0099" size=+2>
<br>
	 Euphoria Database System (EDS)
</font></center>
<p>
<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br> 
 Introduction 
</font>

 <p>
 Many people have expressed an interest in accessing databases using 
 Euphoria programs. Those people have either wanted to access a
 name-brand database management system from Euphoria, or they've 
 wanted a simple, easy-to-use, Euphoria-oriented database for storing data. 
 EDS is the latter. <font color="#006633"><b>It provides a simple,
 extremely flexible, database system 
 for use by Euphoria programs.</b></font>
 
<p>
<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br> 
 Structure of an EDS database
</font> 
 <p>
 In EDS, a <font color="#993333"><b>database</b></font> is a single file
 with <b>.edb</b> file type.
 An EDS database contains 0 or more
 <font color="#993333"><b>tables</b></font>. Each table has a
 <font color="#993333"><b>name</b></font>, and 
 contains 0 or more <font color="#993333"><b>records</b></font>.
 Each record consists of a <font color="#993333"><b>key</b></font> part, 
 and a <font color="#993333"><b>data</b></font> part. The key can be
 <font color="#CC0099"><b>any</b></font> Euphoria object - 
 an atom, a sequence, a deeply-nested sequence, whatever. Similarly the 
 data can be <font color="#CC0099"><b>any</b></font> Euphoria object.
 There are <font color="#CC0099"><b>no</b></font> constraints on the 
 size or structure of the key or data. Within a given table, the keys 
 are all unique. That is, no two records in the same table can have 
 the same key part.
 
 <p>
 The records of a table are stored in ascending order of key value.
 An efficient binary search is used when you refer to a record
 by key. You can also access a record directly, with no search, if you 
 know its current <font color="#993333"><b>record number</b></font> within
 the table. Record numbers are 
 integers from 1 to the length (current number of records) of the table. 
 By incrementing the record number, you can efficiently step through all 
 the records, in order of key. Note however that a record's number can 
 change whenever a new record is inserted, or an existing record is deleted.
 
 <p>
 The keys and data parts are stored in a compact form, but
 <font color="#CC0099"><b>no</b></font> accuracy is 
 lost when saving or restoring floating-point numbers or
 <font color="#CC0099"><b>any</b></font> other Euphoria data.
 
 <p>
 <font color="#5500FF"><b>database.e</b></font> will work as is,
 on <font color="#CC3366"><b>Windows</b></font>,
 <font color="#CC3366"><b>DOS</b></font>,
 <font color="#CC3366"><b>Linux</b></font>
 or <font color="#CC3366"><b>FreeBSD</b></font>. 
 <font color="#006633"><b>EDS database files can be copied and shared
 between programs running on Linux/FreeBSD and DOS/Windows.</b></font>
 Be sure to make an exact byte for byte copy 
 using "binary" mode copying, rather than "text" or "ASCII" mode which
 could change the line terminators.
 
<pre><font color="#330033"> Example:</font>
<font color="#330033">    database: </font><font color="#00A033">"mydata.edb"</font>
<font color="#330033">          first table: </font><font color="#00A033">"passwords"</font>
<font color="#330033">               record #1:  key: </font><font color="#00A033">"jones"   </font><font color="#330033">data: </font><font color="#00A033">"euphor123"</font>
<font color="#330033">               record #2:  key: </font><font color="#00A033">"smith"   </font><font color="#330033">data: </font><font color="#00A033">"billgates"</font>
<font color="#330033">        </font>
<font color="#330033">          second table: </font><font color="#00A033">"parts"</font>
<font color="#330033">               record #1:  key: 134525    data: {</font><font color="#00A033">"hammer"</font><font color="#330033">, 15.95, 500}</font>
<font color="#330033">               record #2:  key: 134526    data: {</font><font color="#00A033">"saw"</font><font color="#330033">, 25.95, 100}</font>
<font color="#330033">               record #3:  key: 134530    data: {</font><font color="#00A033">"screw driver"</font><font color="#330033">, 5.50, 1500}</font>
<font color="#330033">        </font>
</pre>
 It's up to you to interpret the meaning of the key and data.
 <font color="#006633"><b>In keeping with the spirit of Euphoria, you have
 total flexibility.</b></font> 
 Unlike most other database systems, an EDS record is
 <font color="#CC0099"><b><i>not</i></b></font> required to 
 have either a fixed number of fields, or fields with a preset maximum length.
 
 <p>
 In many cases there will not be any natural key value for your records.
 In those cases you should simply create a meaningless, but unique, 
 integer to be the key. Remember that you can always access the data 
 by record number. It's easy to loop through the records looking for 
 a particular field value.

<p>
<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br> 
 How to access the data
</font> 

 <p>
 To reduce the number of parameters that you have to pass,
 there is a notion of the <font color="#993333"><b>current database</b></font>,
 and <font color="#993333"><b>current table</b></font>.
 Most routines use these <b>current</b> values automatically.
 You normally start by opening (or creating) a database file, then
 selecting the table that you want to work with.
 
 <p>
 You can map a key to a record number using
 <a href="database.htm#find_key"><b>db_find_key()</b></a>. It uses
 an efficient binary search. Most of the other record-level routines 
 expect the record number as an argument. You can very quickly access 
 any record, given it's number. You can access all the records by 
 starting at record number 1 and looping through to the record number 
 returned by <a href="database.htm#table_size"><b>db_table_size()</b></a>.
 
<p>
<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br> 
 How does storage get recycled?
</font> 

<p>
 When you delete something, such as a record, the space for that item
 gets put on a free list, for future use. Adjacent free areas are 
 combined into larger free areas. When more space is needed, and no 
 suitable space is found on the free list, the file will grow in size.
 Currently there is no automatic way that a file will shrink in size, 
 but you can use <a href="database.htm#compress"><b>db_compress()</b></a> to
 completely rewrite a database, removing the unused spaces.

<p>
<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br> 
 Security / Multi-user Access
</font> 

<p>
 This release provides a simple way to lock an entire database to prevent
 unsafe access by other processes.

<p>
<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br> 
 Scalability
</font> 

<p>
 Internal pointers are 4 bytes. In theory that limits the size of a 
 database file to 4 Gb. In practice, the limit is 2 Gb because of
 limitations in various C file functions used by Euphoria.
 Given enough user demand, EDS databases could be expanded well beyond
 2 Gb in the future.
 
<p> 
 The current algorithm allocates 4 bytes of memory per record in the 
 current table. So you'll need at least 4Mb RAM per million records
 on disk.
<p> 
 The binary search for keys should work reasonably well for large tables. 
<p> 
 Inserts and deletes take slightly longer as a table gets larger. 
<p> 
 At the low end of the scale, it's possible to create extremely small
 databases without incurring much disk space overhead.

<p>
<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br> 
 Disclaimer
</font> 

 <p>
 Do not store valuable data without a backup. 
 RDS will not be responsible for any damage or data loss.

<p>
<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br> 
 Warning
</font> 

 <p>
 .edb files are binary files, not text files. 
 You *must* use BINARY mode when transferring a .edb file
 via FTP from one machine to another. You must also avoid
 loading a .edb file into an editor and saving it. If you 
 open a .edb file directly using Euphoria's open(), 
 which is not recommended, you must use binary mode, not text mode. 
 Failure to follow these rules could result in 10 (line-feed) 
 and 13 (carriage-return) bytes being changed, leading to subtle 
 and not-so-subtle forms of corruption in your database.
 
<p>
<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br> 
 Database Routines
</font> 

<p>
 In the descriptions below, to indicate what kind of
 <font color="#993333"><b>object</b></font> may
 be passed in and returned, the following prefixes are used:

<center><table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b>x</b></td>
<td width=10 align=center valign=top>-</td>
<td>a general <a href="refman_2.htm#1">object</a>
     (atom or sequence)</td></tr>


<tr><td valign=top><b>s</b></td>
<td width=10 align=center valign=top>-</td>
<td>a <a href="refman_2.htm#1">sequence</a></td></tr>


<tr><td valign=top><b>a</b></td>
<td width=10 align=center valign=top>-</td>
<td>an <a href="refman_2.htm#1">atom</a></td></tr>


<tr><td valign=top><b>i</b></td>
<td width=10 align=center valign=top>-</td>
<td>an <a href="refman_2.htm#integer">integer</a></td></tr>


<tr><td valign=top><b>fn</b></td>
<td width=10 align=center valign=top>-</td>
<td>an <a href="refman_2.htm#integer">integer</a> used
     as a file number</td></tr>


<tr><td valign=top><b>st</b></td>
<td width=10 align=center valign=top>-</td>
<td>a <a href="refman_2.htm#11">string sequence</a>,
     or <a href="refman_2.htm#char">single-character atom</a></td></tr>


</table></center>

<p>

<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><a href="database.htm#create"><b>db_create</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>create a new database</td></tr>


<tr><td valign=top><a href="database.htm#open"><b>db_open</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>open an existing database</td></tr>


<tr><td valign=top><a href="database.htm#select"><b>db_select</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>select a database to be the current one</td></tr>


<tr><td valign=top><a href="database.htm#close"><b>db_close</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>close a database</td></tr>


<tr><td valign=top><a href="database.htm#create_table"><b>db_create_table</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>create a new table within a database</td></tr>


<tr><td valign=top><a href="database.htm#select_table"><b>db_select_table</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>select a table to be the current one</td></tr>


<tr><td valign=top><a href="database.htm#rename_table"><b>db_rename_table</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>rename a table</td></tr>


<tr><td valign=top><a href="database.htm#delete_table"><b>db_delete_table</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>delete a table</td></tr>


<tr><td valign=top><a href="database.htm#table_list"><b>db_table_list</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>get a list of all the table names in a database</td></tr>


<tr><td valign=top><a href="database.htm#table_size"><b>db_table_size</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>get the number of records in the current table</td></tr>


<tr><td valign=top><a href="database.htm#find_key"><b>db_find_key</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>quickly find the record with a certain key value</td></tr>


<tr><td valign=top><a href="database.htm#record_key"><b>db_record_key</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>get the key portion of a record</td></tr>


<tr><td valign=top><a href="database.htm#record_data"><b>db_record_data</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>get the data portion of a record</td></tr>


<tr><td valign=top><a href="database.htm#insert"><b>db_insert</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>insert a new record into the current table</td></tr>


<tr><td valign=top><a href="database.htm#delete_record"><b>db_delete_record</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>delete a record from the current table</td></tr>


<tr><td valign=top><a href="database.htm#replace_data"><b>db_replace_data</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>replace the data portion of a record</td></tr>


<tr><td valign=top><a href="database.htm#compress"><b>db_compress</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>compress a database</td></tr>


<tr><td valign=top><a href="database.htm#dump"><b>db_dump</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>print the contents of a database</td></tr>


<tr><td valign=top><a href="database.htm#fatal_id"><b>db_fatal_id</b></a></td>
<td width=10 align=center valign=top>-</td>
<td>handle fatal database errors</td></tr>


</table>

<p>
<hr>

<a name=create></a>
<a name=db_create></a><font color="#006633" size=+2><br>
<center><b>db_create</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>


 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica">include database.e<BR>
 i1 = db_create(s, i2)
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>Create a new database. A new database will be created in the file with path
 given by s. i2 indicates the type of lock that will be applied to the file
 as it is created. i1 is an error code that indicates success or failure.
 The values for i2 can be either DB_LOCK_NO (no lock) or 
 DB_LOCK_EXCLUSIVE (exclusive lock). i1
 is DB_OK if the new database is successfully created. This database
 becomes the <font color="#993333"><b>current database</b></font> to which
 all other database operations will apply.
</td></tr>

<tr><td valign=top><b>Comments:</b></td>
<td>If the path, s, does not end in .edb, it will be added automatically.
 <p>If the database already exists, it will not be overwritten.
 db_create() will return DB_EXISTS_ALREADY.
 <p>A version number is stored in the database file so future
 versions of the database software can recognize the format, and
  possibly read it and deal with it in some way.
</td></tr>

<tr><td valign=top><b>Example:</b></td>
<td>
</td></tr>

<tr><td></td><td>
<pre><font color="#0000FF">if </font><font color="#330033">db_create(</font><font color="#00A033">"mydata"</font><font color="#330033">, DB_LOCK_NO) != DB_OK </font><font color="#0000FF">then</font>
<font color="#FF00FF">    puts</font><font color="#330033">(2, </font><font color="#00A033">"Couldn't create the database!\n"</font><font color="#330033">)</font>
<font color="#FF00FF">    abort</font><font color="#330033">(1)</font>
<font color="#0000FF">end if</font>
</pre></td></tr>

<tr><td valign=top><b>See Also:</b></td>
<td><a href="database.htm#db_open">db_open</a>,
               <a href="database.htm#db_close">db_close</a>
</td></tr>

</table>


<a name=open></a>
<a name=db_open></a><font color="#006633" size=+2><br>
<center><b>db_open</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>


 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica"> include database.e<BR>
 i1 = db_open(s, i2)
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>Open an existing Euphoria database. The file containing the database is
 given by s. i1 is a return code indicating success or failure.
 i2 indicates the type of lock that you want to place on the database
 file while you have it open. This database
 becomes the <font color="#993333"><b>current database</b></font> to
 which all other database operations will apply.
 <p>The return codes are:
</td></tr>


<tr><td></td><td>
<pre><font color="#0000FF">    global constant </font><font color="#330033">DB_OK = 0   </font><font color="#FF0055">-- success</font>
<font color="#330033">             DB_OPEN_FAIL = -1  </font><font color="#FF0055">-- couldn't open the file </font>
<font color="#330033">             DB_LOCK_FAIL = -3  </font><font color="#FF0055">-- couldn't lock the file in the</font>
<font color="#FF0055">                                --     manner requested</font>
</pre></td></tr>


<tr><td valign=top><b>Comments:</b></td>
<td>The types of lock that you can use are: DB_LOCK_NO (no lock), 
 DB_LOCK_SHARED (shared lock for read-only access) and
 DB_LOCK_EXCLUSIVE (for read/write access). DB_LOCK_SHARED is only supported on
 <font color="#CC3366"><b>Linux</b></font>/<font color="#CC3366"><b>FreeBSD</b></font>.
 It allows you to read the database, but not write anything to it. If you
 request DB_LOCK_SHARED on <font color="#CC3366"><b>WIN32</b></font> or
 <font color="#CC3366"><b>DOS32</b></font> it will be treated as if you had
 asked for DB_LOCK_EXCLUSIVE.<P>
  If the lock fails, your program should wait a few seconds and try again.
  Another process might be currently accessing the database.<P>
  DOS programs will typically get a "critical error" message if they
  try to access a database that is currently locked.
</td></tr>

<tr><td valign=top><b>Example:</b></td>
<td>
</td></tr>

<tr><td></td><td>
<pre><font color="#330033">tries = 0</font>
<font color="#0000FF">while </font><font color="#330033">1 </font><font color="#0000FF">do</font>
<font color="#330033">    err = db_open(</font><font color="#00A033">"mydata"</font><font color="#330033">, DB_LOCK_SHARED) </font>
<font color="#0000FF">    if </font><font color="#330033">err = DB_OK </font><font color="#0000FF">then</font>
<font color="#0000FF">        exit</font>
<font color="#0000FF">    elsif </font><font color="#330033">err = DB_LOCK_FAIL </font><font color="#0000FF">then</font>
<font color="#330033">    	tries += 1</font>
<font color="#0000FF">    	if </font><font color="#330033">tries > 10 </font><font color="#0000FF">then</font>
<font color="#FF00FF">            puts</font><font color="#330033">(2, </font><font color="#00A033">"too many tries, giving up\n"</font><font color="#330033">)</font>
<font color="#FF00FF">            abort</font><font color="#330033">(1)</font>
<font color="#0000FF">    	else    </font>
<font color="#330033">    	    sleep(5)</font>
<font color="#0000FF">    	end if</font>
<font color="#0000FF">    else</font>
<font color="#FF00FF">    	puts</font><font color="#330033">(2, </font><font color="#00A033">"Couldn't open the database!\n"</font><font color="#330033">)</font>
<font color="#FF00FF">    	abort</font><font color="#330033">(1)</font>
<font color="#0000FF">    end if</font>
<font color="#0000FF">end while</font>
<font color="#330033"></font>
</pre></td></tr>


 <tr><td valign=top><b>See Also:</b></td>
<td><a href="database.htm#db_create">db_create</a>,
               <a href="database.htm#db_close">db_close</a>
</td></tr>

</table>


<a name=select></a>
<a name=db_select></a><font color="#006633" size=+2><br>
<center><b>db_select</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>


 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica"> include database.e<BR>
 i = db_select(s)
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>Choose a new, already open, database to be the
 <font color="#993333"><b>current database</b></font>.
 Subsequent database operations will apply to this database. s is the
 path of the database file as it was originally opened with db_open() or
 db_create(). i is a return code indicating success (DB_OK) or failure.
</td></tr>

<tr><td valign=top><b>Comments:</b></td>
<td>When you create (db_create) or open (db_open)
  a database, it automatically becomes the current database.
  Use db_select() when you want to switch back and forth between
  open databases, perhaps to copy records 
  from one to the other.<p>
  After selecting a new database, you should select a table
  within that database using db_select_table().
</td></tr>


<tr><td valign=top><b>Example:</b></td>
<td>
</td></tr>

<tr><td></td><td>
<pre><font color="#0000FF">if </font><font color="#330033">db_select(</font><font color="#00A033">"employees"</font><font color="#330033">) != DB_OK </font><font color="#0000FF">then</font>
<font color="#FF00FF">    puts</font><font color="#330033">(2, </font><font color="#00A033">"Couldn't select employees database\n"</font><font color="#330033">)</font>
<font color="#0000FF">end if</font>
</pre></td></tr>

<tr><td valign=top><b>See Also:</b></td>
<td><a href="database.htm#db_open">db_open</a>
</td></tr>

</table>


<a name=close></a>
<a name=db_close></a><font color="#006633" size=+2><br>
<center><b>db_close</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>


 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica">include database.e<BR>
 db_close()
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>Unlock and close the <font color="#993333"><b>current database</b></font>.
</td></tr>

<tr><td valign=top><b>Comments:</b></td>
<td>Call this procedure when you are finished with the current database.
 Any lock will be removed, allowing other processes to access 
 the database file.
</td></tr>


 <tr><td valign=top><b>See Also:</b></td>
<td><a href="database.htm#db_open">db_open</a>
</td></tr>

</table>

<a name=create_table></a>
<a name=db_create_table></a><font color="#006633" size=+2><br>
<center><b>db_create_table</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>


 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica">include database.e<BR>
 i = db_create_table(s)
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>Create a new table within the
 <font color="#993333"><b>current database</b></font>. The name of the
 table is given by the sequence of characters, s, and may not be the same
 as any existing table in the current database.
</td></tr>

<tr><td valign=top><b>Comments:</b></td>
<td>The table that you create will initially have 0 records.
 It becomes the <font color="#993333"><b>current table</b></font>.
</td></tr>

<tr><td valign=top><b>Example:</b></td>
<td>
</td></tr>

<tr><td></td><td>
<pre><font color="#0000FF">if </font><font color="#330033">db_create_table(</font><font color="#00A033">"my_new_table"</font><font color="#330033">) != DB_OK </font><font color="#0000FF">then</font>
<font color="#FF00FF">    puts</font><font color="#330033">(2, </font><font color="#00A033">"Couldn't create my_new_table!\n"</font><font color="#330033">)</font>
<font color="#0000FF">end if</font>
</pre></td></tr>

<tr><td valign=top><b>See Also:</b></td>
<td><a href="database.htm#db_delete_table">db_delete_table</a>
</td></tr>

</table>

<a name=select_table></a>
<a name=db_select_table></a><font color="#006633" size=+2><br>
<center><b>db_select_table</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>


 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica">include database.e<BR>
 i = db_select_table(s)
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>The table with name given by s,
 becomes the <font color="#993333"><b>current table</b></font>.
 The return code, i, will be DB_OK if the table exists in the 
 <font color="#993333"><b>current database</b></font>, otherwise you'll
 get DB_OPEN_FAIL.
</td></tr>


<tr><td valign=top><b>Comments:</b></td>
<td>All record-level database operations apply automatically 
  to the current table.
</td></tr>

<tr><td valign=top><b>Example:</b></td>
<td>
</td></tr>

<tr><td></td><td>
<pre><font color="#0000FF">if </font><font color="#330033">db_select_table(</font><font color="#00A033">"salary"</font><font color="#330033">) != DB_OK </font><font color="#0000FF">then</font>
<font color="#FF00FF">    puts</font><font color="#330033">(2, </font><font color="#00A033">"Couldn't find salary table!\n"</font><font color="#330033">)</font>
<font color="#FF00FF">    abort</font><font color="#330033">(1)</font>
<font color="#0000FF">end if</font>
</pre></td></tr>


 <tr><td valign=top><b>See Also:</b></td>
<td>
  <a href="database.htm#db_create_table">db_create_table</a>,
  <a href="database.htm#db_delete_table">db_delete_table</a>
</td></tr>

</table>

<a name=rename_table></a>
<a name=db_rename_table></a><font color="#006633" size=+2><br>
<center><b>db_rename_table</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>


 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica">include database.e<br>
  db_rename_table(s1, s2)
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>Rename a table in the <font color="#993333"><b>current database</b></font>.
The current name of the table is given by s1. The new name of the table is s2.
</td></tr>

<tr><td valign=top><b>Comments:</b></td>
<td>The table to be renamed can be the 
 <font color="#993333"><b>current table</b></font>, 
 or some other table in the current database.
 An error will occur if s1 is not the name of a table in the current database,
 or if s2 <b>is</b> the name of an existing table in the current database.
</td></tr>


<tr><td valign=top><b>See Also:</b></td>
<td><a href="database.htm#db_create_table">db_create_table</a>
               <a href="database.htm#db_select_table">db_select_table</a>
               <a href="database.htm#db_delete_table">db_delete_table</a>
</td></tr>

</table>


<a name=delete_table></a>
<a name=db_delete_table></a><font color="#006633" size=+2><br>
<center><b>db_delete_table</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>


 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica">include database.e<br>
  db_delete_table(s)
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>Delete a table in the <font color="#993333"><b>current database</b></font>.
The name of the table is given by s.
</td></tr>

<tr><td valign=top><b>Comments:</b></td>
<td>All records are deleted and all space used by the table is freed up.
 If the table is the <font color="#993333"><b>current table</b></font>,
 the <font color="#993333"><b>current table</b></font> becomes undefined.<p>
 If there is no table with the name given by s, then nothing happens.
</td></tr>


<tr><td valign=top><b>See Also:</b></td>
<td><a href="database.htm#db_create_table">db_create_table</a>
               <a href="database.htm#db_select_table">db_select_table</a>
</td></tr>

</table>


<a name=table_list></a>
<a name=db_table_list></a><font color="#006633" size=+2><br>
<center><b>db_table_list</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>


 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica">s = db_table_list()
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>Return a sequence of all the table names in the
<font color="#993333"><b>current database</b></font>. Each
element of s is a sequence of characters containing the name of a table.
</td></tr>

<tr><td valign=top><b>Example:</b></td>
<td>
</td></tr>

<tr><td></td><td>
<pre><font color="#FF00FF">sequence </font><font color="#330033">names</font>
<font color="#330033"></font>
<font color="#330033">names = db_table_list()</font>
<font color="#0000FF">for </font><font color="#330033">i = 1 </font><font color="#0000FF">to </font><font color="#FF00FF">length</font><font color="#330033">(names) </font><font color="#0000FF">do</font>
<font color="#FF00FF">    puts</font><font color="#330033">(1, names</font><font color="#993333">[</font><font color="#330033">i</font><font color="#993333">] </font><font color="#330033">& </font><font color="#00A033">'\n'</font><font color="#330033">)</font>
<font color="#0000FF">end for</font>
</pre></td></tr>

<tr><td valign=top><b>See Also:</b></td>
<td><a href="database.htm#db_create_table">db_create_table</a>
</td></tr>

</table>

<a name=table_size></a>
<a name=db_table_size></a><font color="#006633" size=+2><br>
<center><b>db_table_size</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>

 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica">include database.e<BR>
 i = db_table_size()
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>Return the current number of records in the
 <font color="#993333"><b>current table</b></font>.
</td></tr>

<tr><td valign=top><b>Example:</b></td>
<td>
</td></tr>

<tr><td></td><td>
<pre><font color="#FF0055">-- look at all records in the current table</font>
<font color="#0000FF">for </font><font color="#330033">i = 1 </font><font color="#0000FF">to </font><font color="#330033">db_table_size() </font><font color="#0000FF">do</font>
<font color="#0000FF">    if </font><font color="#330033">db_record_key(i) = 0 </font><font color="#0000FF">then</font>
<font color="#FF00FF">    	puts</font><font color="#330033">(1, </font><font color="#00A033">"0 key found\n"</font><font color="#330033">)</font>
<font color="#0000FF">    	exit</font>
<font color="#0000FF">    end if</font>
<font color="#0000FF">end for</font>
</pre></td></tr>

<tr><td valign=top><b>See Also:</b></td>
<td><a href="database.htm#db_select_table">db_select_table</a>
</td></tr>

</table>

<a name=find_key></a>
<a name=db_find_key></a><font color="#006633" size=+2><br>
<center><b>db_find_key</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>

 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica">include database.e<BR>
  i = db_find_key(x)
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>Find the record in the <font color="#993333"><b>current table</b></font>
 with key value x. If found,
 the record number will be returned. If not found, the record number
 that key would occupy, if inserted, is returned as a negative number.
</td></tr>


<tr><td valign=top><b>Comments:</b></td>
<td>A fast binary search is used to find the key in the
  current table. The number of comparisons is proportional
  to the log of the number of records in the table.
  <p>
  You can select a range of records by searching for the first and
  last key values in the range. If those key values don't exist,
  you'll at least get a negative value showing where they would be, 
  if they existed.
  e.g. Suppose you want to know which records have keys greater than "GGG"
  and less than "MMM". If -5 is returned for key "GGG", it means 
  a record with "GGG" as a key would be inserted as record number 5. 
  -27 for "MMM" means a record with "MMM" as its key would 
  be inserted as record number 27. This quickly tells you that
  all records, >= 5 and < 27 qualify.
</td></tr>


<tr><td valign=top><b>Example:</b></td>
<td>
</td></tr>

<tr><td></td><td>
<pre><font color="#330033">rec_num = db_find_key(</font><font color="#00A033">"Millennium"</font><font color="#330033">)</font>
<font color="#0000FF">if </font><font color="#330033">rec_num > 0 </font><font color="#0000FF">then</font>
<font color="#330033">    ? db_record_key(rec_num)</font>
<font color="#330033">    ? db_record_data(rec_num)</font>
<font color="#0000FF">else</font>
<font color="#FF00FF">    puts</font><font color="#330033">(2, </font><font color="#00A033">"Not found, but if you insert it,\n"</font><font color="#330033">)</font>
<font color="#FF00FF">    printf</font><font color="#330033">(2, </font><font color="#00A033">"it will be #%d\n"</font><font color="#330033">, -rec_num)</font>
<font color="#0000FF">end if</font>
</pre></td></tr>

<tr><td valign=top><b>See Also:</b></td>
<td><a href="database.htm#db_record_key">db_record_key</a>,
               <a href="database.htm#db_record_data">db_record_data</a>,
               <a href="database.htm#db_insert">db_insert</a>
</td></tr>

</table>

<a name=record_key></a>
<a name=db_record_key></a><font color="#006633" size=+2><br>
<center><b>db_record_key</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>

 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica">include database.e<BR>
 x = db_record_key(i)
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>Return the key portion of record number i in the
 <font color="#993333"><b>current table</b></font>.
</td></tr>

<tr><td valign=top><b>Comments:</b></td>
<td>Each record in a Euphoria database consists of a key portion and
a data portion. Each of these can be any Euphoria atom or sequence.
</td></tr>

<tr><td valign=top><b>Example:</b></td>
<td>
</td></tr>

<tr><td></td><td>
<pre><font color="#FF00FF">puts</font><font color="#330033">(1, </font><font color="#00A033">"The 6th record has key value: "</font><font color="#330033">)</font>
<font color="#330033">? db_record_key(6)</font>
</pre></td></tr>

<tr><td valign=top><b>See Also:</b></td>
<td><a href="database.htm#db_record_data">db_record_data</a>
</td></tr>

</table>

<a name=record_data></a>
<a name=db_record_data></a><font color="#006633" size=+2><br>
<center><b>db_record_data</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>

 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica">include database.e<BR>
 x = db_record_data(i)
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>Return the data portion of record number i in the
 <font color="#993333"><b>current table</b></font>.
</td></tr>

<tr><td valign=top><b>Comments:</b></td>
<td>Each record in a Euphoria database consists of a key portion and
a data portion. Each of these can be any Euphoria atom or sequence.
</td></tr>

<tr><td valign=top><b>Example:</b></td>
<td>
</td></tr>

<tr><td></td><td>
<pre><font color="#FF00FF">puts</font><font color="#330033">(1, </font><font color="#00A033">"The 6th record has data value: "</font><font color="#330033">)</font>
<font color="#330033">? db_record_data(6)</font>
</pre></td></tr>

<tr><td valign=top><b>See Also:</b></td>
<td><a href="database.htm#db_record_key">db_record_key</a>
</td></tr>

</table>

<a name=insert></a>
<a name=db_insert></a><font color="#006633" size=+2><br>
<center><b>db_insert</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>

 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica">include database.e<BR>
  i = db_insert(x1, x2)
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>Insert a new record into the
 <font color="#993333"><b>current table</b></font>. The record
key is x1 and the record data is x2. Both x1 and x2 can be any Euphoria
data objects, atoms or sequences. The return code i1 is DB_OK if the record
is inserted.
</td></tr>

<tr><td valign=top><b>Comments:</b></td>
<td>Within a table, all keys must be unique. db_insert() will fail with
  DB_EXISTS_ALREADY if a record already exists with the same key value.
</td></tr>

<tr><td valign=top><b>Example:</b></td>
<td>
</td></tr>

<tr><td></td><td>
<pre><font color="#0000FF">if </font><font color="#330033">db_insert(</font><font color="#00A033">"Smith"</font><font color="#330033">, </font><font color="#993333">{</font><font color="#00A033">"Peter"</font><font color="#330033">, 100, 34.5</font><font color="#993333">}</font><font color="#330033">) != DB_OK </font><font color="#0000FF">then</font>
<font color="#FF00FF">    puts</font><font color="#330033">(2, </font><font color="#00A033">"insert failed!\n"</font><font color="#330033">)</font>
<font color="#0000FF">end if</font>
</pre></td></tr>

<tr><td valign=top><b>See Also:</b></td>
<td><a href="database.htm#db_find_key">db_find_key</a>,
               <a href="database.htm#db_record_key">db_record_key</a>,
               <a href="database.htm#db_record_data">db_record_data</a>
</td></tr>

</table>

<a name=delete_record></a>
<a name=db_delete_record></a><font color="#006633" size=+2><br>
<center><b>db_delete_record</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>

 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica">include database.e<br>
  db_delete_record(i)
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>Delete record number i from the
 <font color="#993333"><b>current table</b></font>.
</td></tr>

<tr><td valign=top><b>Comments:</b></td>
<td>The record number, i, must be an integer from 1 to the number 
of records in the current table.
</td></tr>

<tr><td valign=top><b>Example:</b></td>
<td>
</td></tr>

<tr><td></td><td>
<pre><font color="#330033">db_delete_record(55)</font>
</pre></td></tr>

<tr><td valign=top><b>See Also:</b></td>
<td><a href="database.htm#db_insert">db_insert</a>,
               <a href="database.htm#db_table_size">db_table_size</a>
</td></tr>

</table>

<a name=replace_data></a>
<a name=db_replace_data></a><font color="#006633" size=+2><br>
<center><b>db_replace_data</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>

 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica">include database.e<br>
  db_replace_data(i, x)
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>In the <font color="#993333"><b>current table</b></font>, replace the
 data portion of record number i, with x.
 x can be any Euphoria atom or sequence.
</td></tr>

<tr><td valign=top><b>Comments:</b></td>
<td>The record number, i, must be from 1 to the number of records in the 
  current table.
</td></tr>

<tr><td valign=top><b>Example:</b></td>
<td>
</td></tr>

<tr><td></td><td>
<pre><font color="#330033">db_replace_data(67, </font><font color="#993333">{</font><font color="#00A033">"Peter"</font><font color="#330033">, 150, 34.5</font><font color="#993333">}</font><font color="#330033">)</font>
</pre></td></tr>

<tr><td valign=top><b>See Also:</b></td>
<td><a href="database.htm#db_delete_record">db_delete_record</a>
</td></tr>

</table>

<a name=compress></a>
<a name=db_compress></a><font color="#006633" size=+2><br>
<center><b>db_compress</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>


 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica">include database.e<BR>
 i = db_compress()
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>Compress the <font color="#993333"><b>current database</b></font>.
 The current database is copied
to a new file such that any blocks of unused space are eliminated. 
If successful, i will be set to DB_OK, and the new compressed database 
file will retain the same name. The current table will be undefined.
As a backup, the original, uncompressed
file will be renamed with an extension of .t0 (or .t1, .t2 ,..., .t99). 
In the highly unusual case that the compression is unsuccessful, 
the database will be left unchanged, and no backup will be made.
</td></tr>

<tr><td valign=top><b>Comments:</b></td>
<td>When you delete items from a database, you create blocks of free
space within the database file. The system keeps track of these blocks and
tries to use them for storing new data that you insert. db_compress() will
copy the current database without copying these free areas. The size of the 
database file may therefore be reduced.
<p>
If the backup filenames reach .t99 you will have to delete some of them.
</td></tr>

<tr><td valign=top><b>Example:</b></td>
<td>
</td></tr>

<tr><td></td><td>
<pre><font color="#0000FF">if </font><font color="#330033">db_compress() != DB_OK </font><font color="#0000FF">then</font>
<font color="#FF00FF">    puts</font><font color="#330033">(2, </font><font color="#00A033">"compress failed!\n"</font><font color="#330033">)</font>
<font color="#0000FF">end if</font>
</pre></td></tr>

<tr><td valign=top><b>See Also:</b></td>
<td>
  <a href="database.htm#db_create">db_create</a>
</td></tr>

</table>

<a name=dump></a>
<a name=db_dump></a><font color="#006633" size=+2><br>
<center><b>db_dump</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>


 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica">include database.e<BR>
 db_dump(fn, i)
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>Print the contents of an already-open Euphoria database.
 The contents are printed to file or device fn.
 All records in all tables are shown. If i is non-zero, 
 then a low-level byte-by-byte dump is also shown. The low-level
 dump will only be meaningful to someone who is familiar
 with the internal format of a Euphoria database.
</td></tr>

<tr><td valign=top><b>Example:</b></td>
<td>
</td></tr>

<tr><td></td><td>
<pre><font color="#0000FF">if </font><font color="#330033">db_open(</font><font color="#00A033">"mydata"</font><font color="#330033">, DB_LOCK_SHARED) != DB_OK </font><font color="#0000FF">then</font>
<font color="#FF00FF">    puts</font><font color="#330033">(2, </font><font color="#00A033">"Couldn't open the database!\n"</font><font color="#330033">)</font>
<font color="#FF00FF">    abort</font><font color="#330033">(1)</font>
<font color="#0000FF">end if</font>
<font color="#330033">fn = </font><font color="#FF00FF">open</font><font color="#330033">(</font><font color="#00A033">"db.txt"</font><font color="#330033">, </font><font color="#00A033">"w"</font><font color="#330033">)</font>
<font color="#330033">db_dump(fn, 0)</font>
<font color="#330033"></font>
</pre></td></tr>

<tr><td valign=top><b>See Also:</b></td>
<td><a href="database.htm#db_open">db_open</a>
</td></tr>

</table>

<a name=fatal_id></a>
<a name=db_fatal_id></a><font color="#006633" size=+2><br>
<center><b>db_fatal_id</b></center>
</font><p>

<table border=0 cellspacing=2 cellpadding=2>

 <tr><td valign=top><b>Syntax:</b></td>
<td><font face = "Arial, Helvetica">include database.e<BR>
 db_fatal_id = i
</font>
</td></tr>

 <tr><td valign=top><b>Description:</b></td>
<td>You can catch certain fatal database errors by installing your own fatal error
handler. Simply overwrite the global variable db_fatal_id with the
routine id of one of your own procedures. The procedure must take
a single argument which is a sequence. When certain errors occur your
procedure will be called with an error message string as the argument. 
Your procedure should end by calling abort().
</td></tr>

<tr><td valign=top><b>Example:</b></td>
<td>
</td></tr>

<tr><td></td><td>
<pre><font color="#0000FF">procedure </font><font color="#330033">my_fatal(</font><font color="#FF00FF">sequence </font><font color="#330033">msg)</font>
<font color="#FF00FF">    puts</font><font color="#330033">(2, </font><font color="#00A033">"A fatal error occurred - " </font><font color="#330033">& msg & </font><font color="#00A033">'\n'</font><font color="#330033">)</font>
<font color="#FF00FF">    abort</font><font color="#330033">(1)</font>
<font color="#0000FF">end procedure</font>
<font color="#330033"></font>
<font color="#330033">db_fatal_id = </font><font color="#FF00FF">routine_id</font><font color="#330033">(</font><font color="#00A033">"my_fatal"</font><font color="#330033">)</font>
</pre></td></tr>

<tr><td valign=top><b>See Also:</b></td>
<td><a href="database.htm#db_close">db_close</a>
</td></tr>

</table>

<p>&nbsp;

</td></tr></table>

</body>
</html>
